#include<bits/stdc++.h>
using namespace std;
#define endl '\n'
typedef long long ll;
ll n, q, a, b, c, l, r, cur=0, ans=0, del=0, pd=0, v[500007], pref[500007];
int main()
{
    ios_base::sync_with_stdio(); cin.tie(); cout.tie();
    cin >> n >> q;
    for(int i=1; i<=n; i++)
    {
        cin >> v[i];
        pref[i]=pref[i-1]+v[i];
    }
    for(int i=1; i<=q; i++)
    {
        cin >> a >> b;
        if(a==1)
        {
            v[b]*=-1;
            for(int j=b; j<=n; j++)
            {
                pref[j]+=v[j]*2;
            }
        }
        else
        {
            cin >> c;
            del=0;
            cur=0;
            ans=0;
            pd=0;
            l=-1;
            r=-1;
            for(int j=b; j<=c; j++)
            {
                if(l==-1)
                {
                    if(v[j]==1)
                    {
                        cur++;
                        l=j;
                        r=j;
                    }
                }
                else
                {
                    if(v[j]==1)
                    {
                        if(del>0) del--;
                        cur++;
                    }
                    else
                    {
                        del++;
                        if(del>cur)
                        {pd++;
                        del--;
                        }
                    }
                    r=j;
                }
                if(l==-1) ans=0;
                else ans=max(ans, r-l+1-del-pd);
            }
            cout << ans << endl;
        }
    }
}
